;-------------------------------------------------------------------------------
; Hogyan írjunk játékot ZX Spectrumra...
; 1. Fejezet - Egyszerű szöveg és grafika
;-------------------------------------------------------------------------------
; Példaprogram 1.5
;-------------------------------------------------------------------------------
; Itt az ideje, hogy módosítsuk előző programunkat, hogy egy mozgó csillag helyett
; valamilyen grafikát jelenítsen meg. 
;-------------------------------------------------------------------------------
; SjAsmPlus v1.07rc verzióval fordítva
;-------------------------------------------------------------------------------

	DEVICE ZXSPECTRUM48

; ide fordítjuk a kódot (32768)
	.org $8000

; címke az sjasmplus számára a kódhossz számításához
start:

	ld	hl, udgs	; UDG-k
	ld	(23675), hl	; UDG rendszerváltozó beállítása
	ld	a, 2		; 2 = felső képernyő
	call	5633		; csatorna nyitás
	ld	a, 21		; 21. sor = a képernyő alja
	ld	(xcoord), a	; kezdeti x koordináta
loop	call	setxy		; x/y koordináta beállítása
	ld	a, 144		; UDG megjelenítése csillag helyett
	rst	16		; megjelenítés
	call	delay		; várakozunk
	call	setxy		; x/y koordináta beállítása
	ld	a, 32		; szóköz ASCII kódja
	rst	16		; régi karakter törlése
	call	setxy		; x/y koordináta beállítása
	ld	hl, xcoord	; függőleges pozíció
	dec	(hl)		; egy sorral feljebb
	ld	a, (xcoord)	; hol is van?
	cp	255		; elhagytuk már a képernyő tetejét?
	jr	nz, loop	; nem, folytassuk
	ret
delay	ld	b, 10		; várakozás hossza
delay0	halt			; megszakításra várakozás
	djnz	delay0 		; ciklus
	ret			; visszatérés
setxy 	ld	a, 22		; AT ASCII kódja
	rst	16		; kiküldés
	ld	a, (xcoord)	; függőleges pozíció
	rst	16 		; kiírás
	ld	a, (ycoord)	; y koordináta
	rst	16		; kiírás
	ret
	
xcoord	defb	0
ycoord	defb	15
udgs	defb	60,126,219,153
	defb	255,255,219,219

; címke az sjasmplus számára a kódhossz számításához
end:

; a lefordított bináris kódot elmenti
	.savebin "pelda_1_5.bin",start,end-start   
